// Badboll 6
// Many beachballs
// This is NOT a perfect solution since the evaluation is sequential.

// This version: Rotations not adjusted at ball collisions. This is fixed in the "non-bad" version,
// intentionally left here as demonstration.

// uses framework Cocoa
// uses framework OpenGL
#define MAIN
#include <stdlib.h>
#include "MicroGlut.h"
#include "GL_utilities.h"
#include "VectorUtils4.h"
#include "glugg.h"
#include "gluggShapes.h"
#include "SimpleGUI.h"
#include "beachball.h"

GLuint program, shadowprogram; // Shader
mat4 projectionMatrix;

gluggModel badboll, floorModel;

// kNumBalls is the max number
#define kNumBalls 100
int numBalls = 10;;
float initNumber = 10.0;

float g = 9.81;

vec3 p[kNumBalls];
vec3 v[kNumBalls];
mat4 diffrot[kNumBalls]; // Current rotation speed
mat4 rotmat[kNumBalls]; // Current rotation

mat4 SetRotation(vec3 v, vec3 n, float radius)
{
	vec3 r = cross(v, n);
	vec3 vn, vp;
	SplitVector(v, n, &vn, &vp);
	mat4 diffrot = ArbRotate(r, -Norm(vp)/radius);
	return diffrot;
}

void TestCollision()
{
	for (int i = 0; i < numBalls; i++)
	for (int j = 0; j < numBalls; j++)
	if (i != j)
	{
		vec3 n = VectorSub(p[i], p[j]);
		if (Norm(n) < 2)
		{
			vec3 vv = VectorSub(v[i], v[j]);
			if (dot(vv, n) < 0)
			{		
//				printf("Hit! %d %d\n", i, j);
				
				vec3 v1n, v2n;
				vec3 v1t, v2t;
				SplitVector(v[i], n, &v1n, &v1t);
				SplitVector(v[j], n, &v2n, &v2t);
				v[i] = VectorAdd(v1t, v2n);
				v[j] = VectorAdd(v2t, v1n);
			}
		}
	}
}

void TestFloor(vec3 *p1, vec3 *v1, mat4 *diffrot)
{
	if (p1->y < 1 && v1->y < 0)
	{
		v1->y = -v1->y;
		p1->y = 1;
		*diffrot = SetRotation(*v1, SetVector(0,1,0), 1.0);
	}
	if (p1->x < -4 && v1->x < 0)
	{
		v1->x = -v1->x;
		p1->x = -4;
		*diffrot = SetRotation(*v1, SetVector(1,0,0), 1.0);
	}
	if (p1->x > 4 && v1->x > 0)
	{
		v1->x = -v1->x;
		p1->x = 4;
		*diffrot = SetRotation(*v1, SetVector(-1,0,0), 1.0);
	}

	if (p1->z > 4 && v1->z > 0)
	{
		v1->z = -v1->z;
		p1->z = 4;
		*diffrot = SetRotation(*v1, SetVector(0,0,-1), 1.0);
	}
	if (p1->z < -15 && v1->z < 0)
	{
		v1->z = -v1->z;
		p1->z = -15;
		*diffrot = SetRotation(*v1, SetVector(0,0,1), 1.0);
	}
}

void display(void)
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    mat4 cam = lookAt(0, 7, 14, 0, 4, 0, 0,1,0);
	
	float dt = 0.001;
	float mass = 0.1;
	float fg = -g*mass;
	float mass3 = 0.5;
	
	float a = fg/mass;

	numBalls = (int) initNumber;
	if (numBalls >= kNumBalls)
		numBalls = kNumBalls-1;

//	printf("v1.y = %f\n", v1.y);

//	v1 = VectorAdd(v1, SetVec3(0, a*dt, 0)); // Gravity only, scaled by 1000 as pseudo-time-step
//	v2 = VectorAdd(v2, SetVec3(0, a*dt, 0)); // Gravity only, scaled by 1000 as pseudo-time-step

//	rotmat1 = Mult(diffrot1, rotmat1);
//	rotmat2 = Mult(diffrot2, rotmat2);

//	p1 = VectorAdd(p1, v1);
//	p2 = VectorAdd(p2, v2);

	for (int i = 0; i < numBalls; i++)
	{
		v[i] = VectorAdd(v[i], SetVec3(0, a*dt, 0)); // Gravity only, scaled by 1000 as pseudo-time-step
		rotmat[i] = Mult(diffrot[i], rotmat[i]);
		p[i] = VectorAdd(p[i], v[i]);
	}

// 1.
	for (int i = 0; i < numBalls; i++)
		TestFloor(&p[i], &v[i], &diffrot[i]);
//	TestFloor(&p1, &v1, &diffrot1);
//	TestFloor(&p2, &v2, &diffrot2);

	TestCollision();
	
	for (int i = 0; i < numBalls; i++)
	{
		glUseProgram(program);
		mat4 m = Mult(Mult(cam, T(p[i].x, p[i].y, p[i].z)), rotmat[i]);
	//	m = Mult(cam, T(p1.x,p1.y, p1.z));
		glUniformMatrix4fv(glGetUniformLocation(program, "modelviewMatrix"), 1, GL_TRUE, m.m);
		gluggDrawModel(badboll, program);
	}

	glUniformMatrix4fv(glGetUniformLocation(program, "modelviewMatrix"), 1, GL_TRUE, cam.m);
	gluggDrawModel(floorModel, program);

// Shadows for all three
// with "cheapness projection", move z by y
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glUseProgram(shadowprogram);

	for (int i = 0; i < numBalls; i++)
	{
		mat4 m = Mult(cam, Mult(T(p[i].x, 0.1, p[i].z), S(1,0,1)));
	    glUniformMatrix4fv(glGetUniformLocation(shadowprogram, "modelviewMatrix"), 1, GL_TRUE, m.m);
		gluggDrawModel(badboll, shadowprogram);
	}

//	m = Mult(cam, Mult(T(p2.x,0.1, p2.z+1), S(1,0,1)));
//    glUniformMatrix4fv(glGetUniformLocation(shadowprogram, "modelviewMatrix"), 1, GL_TRUE, m.m);
//	gluggDrawModel(badboll, shadowprogram);

	glDisable(GL_BLEND);

	
	sgDraw();

    glutSwapBuffers();
}

float initHeight1 = 3;
float initXVelocity1 = 0.05;
float initZVelocity1 = 0.12;

GLfloat randy(void)
{
	GLuint i = (GLuint)rand();
	return (( (GLfloat)i) / RAND_MAX);
}

void Reset()
{
	for (int i = 0; i < numBalls; i++)
	{
		p[i] = SetVec3(-4 + 4 * randy(), randy()*initHeight1, 0);
		v[i] = SetVec3((randy()-0.5)*initXVelocity1, 0, (randy()-0.5)*initZVelocity1);
	}
}

void myinit()
{
    glEnable(GL_DEPTH_TEST); /* enable z buffer */
    glEnable(GL_CULL_FACE);
		
	for (int i = 0; i < kNumBalls; i++)
	{
		rotmat[i] = IdentityMatrix();
		diffrot[i] = IdentityMatrix();
	}
	
	program = loadShaders("sphere.vert", "sphere.frag");
	shadowprogram = loadShaders("sphere.vert", "shadow.frag");

	badboll = badbollSphere(6, 10, 20, 1.0);
	
	// Make floor
	gluggBegin(GLUGG_QUADS);
	gluggNormal(0,1,0);
	gluggColor(0.5, 1, 0.6);
	gluggVertex(5, 0, 5);
	gluggVertex(5, 0, -15);
	gluggVertex(-5, 0, -15);
	gluggVertex(-5, 0, 5);
	// Left wall
	gluggNormal(1,0,0);
	gluggColor(0.5, 1, 0.6);
	gluggVertex(-5, 0, 5);
	gluggVertex(-5, 0, -15);
	gluggVertex(-5, 10, -15);
	gluggVertex(-5, 10, 5);
	// Right wall
	gluggNormal(1,0,0); // ???
	gluggColor(0.5, 1, 0.6);
	gluggVertex(5, 0, 5);
	gluggVertex(5, 10, 5);
	gluggVertex(5, 10, -15);
	gluggVertex(5, 0, -15);
	// Far wall
	gluggNormal(0,0,1);
	gluggColor(0.5, 1, 0.6);
	gluggVertex(5, 10, -15);
	gluggVertex(-5, 10, -15);
	gluggVertex(-5, 0, -15);
	gluggVertex(5, 0, -15);
	floorModel = gluggBuildModel(1);
	
	projectionMatrix = frustum(-0.5, 0.5, -0.5, 0.5, 1.0, 60.0);
	
	glUseProgram(program);
	glUniformMatrix4fv(glGetUniformLocation(program, "projectionMatrix"), 1, GL_TRUE, projectionMatrix.m);
	glUseProgram(shadowprogram);
	glUniformMatrix4fv(glGetUniformLocation(program, "projectionMatrix"), 1, GL_TRUE, projectionMatrix.m);

    glClearColor (1.0, 1.0, 1.0, 1.0);
    
    sgSetPosition(10, 10);
    sgCreateStaticString(-1, -1, "Starting height");
	sgCreateSlider(-1, -1, 200, &initHeight1, 0, 30);
    sgCreateStaticString(-1, -1, "Starting X velocity");
	sgCreateSlider(-1, -1, 200, &initXVelocity1, 0, 2);
    sgCreateStaticString(-1, -1, "Starting Z velocity");
	sgCreateSlider(-1, -1, 200, &initZVelocity1, 0, 2);
    sgCreateStaticString(-1, -1, "Number of balls");
	sgCreateSlider(-1, -1, 100, &initNumber, 2, kNumBalls);
    sgSetTextColor(0,0,0);
    sgSetFrameColor(0,0,0);
    sgCreateButton(-1, -1, "Reset", Reset);

	Reset();
}

void mouse(int button, int state, int x, int y)
{
	sgMouse(state, x, y);
}

void mousedrag(int x, int y)
{
	sgMouseDrag(x, y);
}


int main(int argc, char **argv)
{
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
    glutInitContextVersion(3, 2);
    glutInitWindowSize(500, 500);
    glutRepeatingTimer(15);
    glutCreateWindow("Beachball 6");
    myinit();
    glutDisplayFunc(display);
    glutMouseFunc(mouse);
    glutMotionFunc(mousedrag);
    glutMainLoop();
}
