// Badboll 6
// Many beachballs
// This is NOT a perfect solution since the evaluation is sequential.
// This makes them shake an also go inside each other when having multiple collisions.
// Due to this, I consider this a preliminary version.

// Uses structs for the balls.

// Important feature: Rotations are adjusted at ball collisions!

// uses framework Cocoa
// uses framework OpenGL
#define MAIN
#include <stdlib.h>
#include "MicroGlut.h"
#include "GL_utilities.h"
#include "VectorUtils4.h"
#include "glugg.h"
#include "gluggShapes.h"
#include "SimpleGUI.h"
#include "beachball.h"

GLuint program, shadowprogram; // Shader
mat4 projectionMatrix;

gluggModel badboll, floorModel;

// kNumBalls is the max number
#define kNumBalls 100
int numBalls = 10;;
float initNumber = 10.0;

float g = 9.81;

typedef struct ballRec
{
	vec3 p;
	vec3 v;
	mat4 diffrot; // Current rotation speed
	mat4 rotmat;  // Current rotation
} ballRec;
ballRec ball[kNumBalls];

mat4 SetRotation(vec3 v, vec3 n, float radius)
{
	vec3 r = cross(v, n);
	vec3 vn, vp;
	SplitVector(v, n, &vn, &vp);
	mat4 diffrot = ArbRotate(r, -Norm(vp)/radius);
	return diffrot;
}

vec3 MatrixToVec3(mat4 m)
{
	float a = m.m[9] - m.m[6];
	float b = m.m[4] - m.m[1];
	float c = m.m[2] - m.m[8];
	float angle = acos(( m.m[0] + m.m[5] + m.m[10] - 1)/2);
	if (isnan(angle))
		return(SetVec3(0,0,0));
	float root = sqrt(a*a+c*c+b*b);
	if (root < 0.001)
		return(SetVec3(0,0,0));
	vec3 r;
	r.x = a/root;
	r.y = c/root;
	r.z = b/root;
	
	r = ScalarMult(r, angle);
	
//	if (isnan(r.x))
//					{ printf("angle: %f\n", angle); printf("root: %f\n", root); printMat4(m); exit(0);}
//	if (isnan(r.y))
//					{ printf("angle: %f\n", angle); printf("root: %f\n", root); printMat4(m); exit(0);}
//	if (isnan(r.z))
//					{ printf("angle: %f\n", angle); printf("root: %f\n", root); printMat4(m); exit(0);}
	
	return r;
}

mat4 Vec3ToMatrix(vec3 r)
{
	return ArbRotate(r, Norm(r));
}

void TestCollision()
{
	for (int i = 0; i < numBalls; i++)
	for (int j = 0; j < numBalls; j++)
	if (i != j)
	{
		vec3 n = VectorSub(ball[i].p, ball[j].p);
		if (Norm(n) < 2)
		{
			vec3 vv = VectorSub(ball[i].v, ball[j].v);
			if (dot(vv, n) < 0)
			{		
//				printf("Hit! %d %d\n", i, j);
				
				vec3 v1n, v2n;
				vec3 v1t, v2t;
				SplitVector(ball[i].v, n, &v1n, &v1t);
				SplitVector(ball[j].v, n, &v2n, &v2t);
				ball[i].v = VectorAdd(v1t, v2n);
				ball[j].v = VectorAdd(v2t, v1n);
				
				// Important: Make rotations match
				vec3 r1 = MatrixToVec3(ball[i].diffrot);
				vec3 r2 = MatrixToVec3(ball[j].diffrot);
				vec3 rr = ScalarMult(VectorSub(r1, r2), 0.5);
				ball[i].diffrot = Vec3ToMatrix(rr);
				ball[j].diffrot = InvertMat4(Vec3ToMatrix(rr));
				//printMat4(ball[i].diffrot);
			}
		}
	}
}

void TestFloor(vec3 *p1, vec3 *v1, mat4 *diffrot)
{
	if (p1->y < 1 && v1->y < 0)
	{
		v1->y = -v1->y;
		p1->y = 1;
		*diffrot = SetRotation(*v1, SetVector(0,1,0), 1.0);
	}
	if (p1->x < -4 && v1->x < 0)
	{
		v1->x = -v1->x;
		p1->x = -4;
		*diffrot = SetRotation(*v1, SetVector(1,0,0), 1.0);
	}
	if (p1->x > 4 && v1->x > 0)
	{
		v1->x = -v1->x;
		p1->x = 4;
		*diffrot = SetRotation(*v1, SetVector(-1,0,0), 1.0);
	}

	if (p1->z > 4 && v1->z > 0)
	{
		v1->z = -v1->z;
		p1->z = 4;
		*diffrot = SetRotation(*v1, SetVector(0,0,-1), 1.0);
	}
	if (p1->z < -15 && v1->z < 0)
	{
		v1->z = -v1->z;
		p1->z = -15;
		*diffrot = SetRotation(*v1, SetVector(0,0,1), 1.0);
	}
}

void display(void)
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    mat4 cam = lookAt(0, 7, 14, 0, 4, 0, 0,1,0);
	
	float dt = 0.001;
	float mass = 0.1;
	float fg = -g*mass;
	
	float a = fg/mass;

	numBalls = (int) initNumber;
	if (numBalls >= kNumBalls)
		numBalls = kNumBalls-1;

	for (int i = 0; i < numBalls; i++)
	{
		ball[i].v = VectorAdd(ball[i].v, SetVec3(0, a*dt, 0)); // Gravity only, scaled by 1000 as pseudo-time-step
		ball[i].rotmat = Mult(ball[i].diffrot, ball[i].rotmat);
		ball[i].p = VectorAdd(ball[i].p, ball[i].v);
	}

// 1.
	for (int i = 0; i < numBalls; i++)
		TestFloor(&ball[i].p, &ball[i].v, &ball[i].diffrot);

	TestCollision();
	
	for (int i = 0; i < numBalls; i++)
	{
		glUseProgram(program);
		mat4 m = Mult(Mult(cam, T(ball[i].p.x, ball[i].p.y, ball[i].p.z)), ball[i].rotmat);
	//	m = Mult(cam, T(p1.x,p1.y, p1.z));
		glUniformMatrix4fv(glGetUniformLocation(program, "modelviewMatrix"), 1, GL_TRUE, m.m);
		gluggDrawModel(badboll, program);
	}

	glUniformMatrix4fv(glGetUniformLocation(program, "modelviewMatrix"), 1, GL_TRUE, cam.m);
	gluggDrawModel(floorModel, program);

// Shadows for all balls
// with "cheapness projection", move z by y
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glUseProgram(shadowprogram);

// Use stencil buffer to make shadows OK
	glEnable(GL_STENCIL_TEST);
	glClearStencil(0); // Specify value for glClear to set stencil to.
	glClear(GL_STENCIL_BUFFER_BIT);
	glStencilOp(GL_KEEP, GL_KEEP, GL_INCR);
	glStencilFunc(GL_EQUAL, 0, 0xFFFFFFFF);
	glDepthFunc(GL_LEQUAL);

	for (int i = 0; i < numBalls; i++)
	{
		mat4 m = Mult(cam, Mult(T(ball[i].p.x, 0.05, ball[i].p.z), S(1,0,1)));
	    glUniformMatrix4fv(glGetUniformLocation(shadowprogram, "modelviewMatrix"), 1, GL_TRUE, m.m);
		gluggDrawModel(badboll, shadowprogram);
	}

	glDisable(GL_BLEND);
	glDisable(GL_STENCIL_TEST);
	
	sgDraw();

    glutSwapBuffers();
}

float initHeight1 = 3;
float initXVelocity1 = 0.05;
float initZVelocity1 = 0.12;

GLfloat randy(void)
{
	GLuint i = (GLuint)rand();
	return (( (GLfloat)i) / RAND_MAX);
}

void Reset()
{
	for (int i = 0; i < numBalls; i++)
	{
		ball[i].p = SetVec3(-4 + 4 * randy(), randy()*initHeight1, 0);
		ball[i].v = SetVec3((randy()-0.5)*initXVelocity1, 0, (randy()-0.5)*initZVelocity1);
	}
}

void myinit()
{
    glEnable(GL_DEPTH_TEST); /* enable z buffer */
    glEnable(GL_CULL_FACE);
		
	for (int i = 0; i < kNumBalls; i++)
	{
		ball[i].rotmat = IdentityMatrix();
		ball[i].diffrot = IdentityMatrix();
	}
	
	program = loadShaders("sphere.vert", "sphere.frag");
	shadowprogram = loadShaders("sphere.vert", "shadow.frag");

	badboll = badbollSphere(6, 10, 20, 1.0);
	
	// Make floor
	gluggBegin(GLUGG_QUADS);
	gluggNormal(0,1,0);
	gluggColor(0.5, 1, 0.6);
	gluggVertex(5, 0, 5);
	gluggVertex(5, 0, -15);
	gluggVertex(-5, 0, -15);
	gluggVertex(-5, 0, 5);
	// Left wall
	gluggNormal(1,0,0);
	gluggColor(0.5, 1, 0.6);
	gluggVertex(-5, 0, 5);
	gluggVertex(-5, 0, -15);
	gluggVertex(-5, 10, -15);
	gluggVertex(-5, 10, 5);
	// Right wall
	gluggNormal(1,0,0); // ???
	gluggColor(0.5, 1, 0.6);
	gluggVertex(5, 0, 5);
	gluggVertex(5, 10, 5);
	gluggVertex(5, 10, -15);
	gluggVertex(5, 0, -15);
	// Far wall
	gluggNormal(0,0,1);
	gluggColor(0.5, 1, 0.6);
	gluggVertex(5, 10, -15);
	gluggVertex(-5, 10, -15);
	gluggVertex(-5, 0, -15);
	gluggVertex(5, 0, -15);
	floorModel = gluggBuildModel(1);
	
	projectionMatrix = frustum(-0.5, 0.5, -0.5, 0.5, 1.0, 60.0);
	
	glUseProgram(program);
	glUniformMatrix4fv(glGetUniformLocation(program, "projectionMatrix"), 1, GL_TRUE, projectionMatrix.m);
	glUseProgram(shadowprogram);
	glUniformMatrix4fv(glGetUniformLocation(program, "projectionMatrix"), 1, GL_TRUE, projectionMatrix.m);

    glClearColor (1.0, 1.0, 1.0, 1.0);
    
    sgSetPosition(10, 10);
    sgCreateStaticString(-1, -1, "Starting height");
	sgCreateSlider(-1, -1, 200, &initHeight1, 0, 30);
    sgCreateStaticString(-1, -1, "Starting X velocity");
	sgCreateSlider(-1, -1, 200, &initXVelocity1, 0, 2);
    sgCreateStaticString(-1, -1, "Starting Z velocity");
	sgCreateSlider(-1, -1, 200, &initZVelocity1, 0, 2);
    sgCreateStaticString(-1, -1, "Number of balls");
	sgCreateSlider(-1, -1, 100, &initNumber, 2, kNumBalls);
    sgSetTextColor(0,0,0);
    sgSetFrameColor(0,0,0);
    sgCreateButton(-1, -1, "Reset", Reset);

	Reset();
}

void mouse(int button, int state, int x, int y)
{
	sgMouse(state, x, y);
}

void mousedrag(int x, int y)
{
	sgMouseDrag(x, y);
}


int main(int argc, char **argv)
{
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH | GLUT_STENCIL);
    glutInitContextVersion(3, 2);
    glutInitWindowSize(500, 500);
    glutCreateWindow("Many beachballs");
    myinit();
    glutRepeatingTimer(15);
    glutDisplayFunc(display);
    glutMouseFunc(mouse);
    glutMotionFunc(mousedrag);
    glutMainLoop();
}
